Smart Proxy - Bug #9713

Restore WIN32 service functionality
03/11/2015 06:52 AM - Martin Matuska

Status: Closed
Priority: Normal
Assignee:
Category: Core
Target version: 1.9.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/smart-pro
xy/pull/274
Description

Since smart-proxy 1.5, the WIN32 service functionality is broken. To restore it a Gemfile.in must be created or the bundler vs
bundler_ext used differently. In addition, the service code removed in commit 038fa6¢f7079880b16d998346d05112acefec81e needs
to be reintroduced.

Related issues:
Related to Smart Proxy - Bug #8793: Smart-proxy does not run as a service on ... Duplicate 12/26/2014

Associated revisions

Revision a02e0f18 - 05/05/2015 09:03 AM - Martin Matuska
Fixes #9713: restore WIN32 service support

History

#1 - 03/11/2015 06:54 AM - Dominic Cleal
- Project changed from Foreman to Smart Proxy

- Category changed from Smart Proxy to Core

#2 - 04/07/2015 11:22 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/274 added
- Pull request deleted ()

#3 - 04/08/2015 10:17 PM - Zak Herner

- Related to Bug #8793: Smart-proxy does not run as a service on Windows added

#4 - 04/29/2015 04:02 PM - Benjamin Papillon

To not add too much non dev comments on the pr, here are my findings regarding the tests of this patch.

First, as mchesler found, Ruby 1.9 now uses RUBY_PLATFORM to detect the platform ruby is on. Here is the output frop irb :

irb (main) :001:0> puts RUBY_PLATFORM
1386-mingw32

=> nil

irb (main) :002:0> puts RUBY_VERSION
1.9.3

=> nil

After disabling the checks in register-service.rb, | also commented the following line of register-service.rb because your script is not accepting any

argument:

cmd += ' —--service'
Last, | had to install 2 gems : "highline" and "win32-service" gems because the registration script depends on them and the gems are not bundled.
The service registration worked fine after that.

Once the service is registered, | tried to start the service. First, | tried to start the service in command line (to check any ruby issues) then from the
windows services.

As per registration script, | bypassed the check on PLATFORM to check further.
| had a strange effect with requiring libraries. Here is the irb output of require lines:

C:\AA\foreman\smart\bin>irb

<path("../../lib", __FILE_ ), File.expand_path("../../modules", _ FILE_ )1])

=> ["C:/AA/foreman/smart/1lib", "C:/AA/foreman/smart/modules", "C:/Rubyl93/1lib/ru
by/site_ruby/1.9.1", "C:/Rubyl93/lib/ruby/site_ruby/1.9.1/i386-msvcrt", "C:/Ruby
193/1ib/ruby/site_ruby", "C:/Rubyl93/lib/ruby/vendor_ruby/1.9.1", "C:/Rubyl93/1i
b/ruby/vendor_ruby/1.9.1/1i386-msvcrt", "C:/Rubyl93/1ib/ruby/vendor_ruby", "C:/Ru
byl193/1ib/ruby/1.9.1", "C:/Rubyl93/1lib/ruby/1.9.1/i386-mingw32"]
irb(main) : 002:0> require 'smart_proxy'

=> true
irb(main) : 003:0> require 'win32/daemon'
LoadError: cannot load such file —-- win32/daemon

from (irb) :3:in "~ require'

from (irb):3

from C:/Rubyl93/bin/irb:12:in "<main>'
irb(main) :004:0> exit
C:\AA\foreman\smart\bin>
If | execute the line
SLOAD_PATH.unshift (*Dir[File.expand_path("../../1lib", __FILE__ ), File.expand_path("../../modules", _ FILE_ )])
before require 'win32/daemon’, the daemon library refuse to load. This is strange because code is correct. printing $LOAD_PATH before and after the
line shows expected values.
The workaround | found was to require win32/daemon and include Win32 before LOAD_PATH dance (yes it is very hackish and | admit not
understanding everything I'm doing :D)
Let's continue understanding the code :)
Line 12 and 13 I'm seeing a comment insisting to have a complete path for the logfile on windows and we have a relative path just below. Not sure it
will work ;-)
Well, executing the scritp, fails. Correcting the logfile variable with the complete path, my line become :

logfile = "C:\\aa\\foreman\\proxyservice.log"

Yes | know, logdfile is hardcoded for the moment, testing purposes :) The good way would have been reuse settings.yml option.
Be careful, you need double backslashes or it will not work.

Now every small bugs have been fixed, it is time to see how well our proxy is starting :

C:\AA\foreman\smart\bin>net start "smart proxy"
The service is not responding to the control function.

More help is available by typing NET HELPMSG 2186.

No logs are created. | don't know what is happening at all :/

#5 - 05/05/2015 10:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a02e0f18b4e7358becedf27cf3189dee59beadd3.

#6 - 05/05/2015 10:48 AM - Anonymous
- Status changed from Closed to Ready For Testing

#7 - 05/05/2015 10:51 AM - Anonymous
- Status changed from Ready For Testing to Closed
https://projects.theforeman.org/projects/smart-proxy/repository/7/revisions/a02e0f18b4e7358becedf27cf3189dee59bea4d3

#8 - 05/11/2015 05:33 AM - Dominic Cleal

- translation missing: en.field_release set to 35
